name = "[DST]Skin System"
description = "Port DST Skins"
author = "zzzzzzzs"
version = "20240329.3"
forumthread = ""
icon_atlas = "modicon.xml"
icon = "modicon.tex"
api_version = 6
priority = 1000000
dont_starve_compatible = true
reign_of_giants_compatible = true
shipwrecked_compatible = true
hamlet_compatible = true
configuration = { {
  name = "wormwood",
  label = "Wormwood Flowers Extender",
  options = { {
    description = "Yes",
    data = true
  }, {
    description = "No",
    data = false
  } },
  default = false
}, {
  name = "fx",
  label = "Use Skin FX",
  options = { {
    description = "Yes",
    data = "true"
  }, {
    description = "No",
    data = "false"
  } },
  default = "false"
}, {
  name = "fix01",
  label = "Fix Invisible Tools",
  options = { {
    description = "Use Bugged Anim",
    data = "true"
  }, {
    description = "Keep Invisible",
    data = "false"
  }, {
    description = "Don't Reskin",
    data = "refuse"
  } },
  default = "true"
} }
translation = { {
  matchLanguage = function(lang)
    return lang == "zh" or lang == "zht" or lang == "zhr" or lang == "chs" or lang == "cht"
  end,
  translateFunction = function(key) return translation[1].dict[key] or nil end,
  dict = {
    name = "皮肤系统",
    unusable = "不可用",
    description = [[搬运DST皮肤]],
    version = "版本：拾荒斗士",
    No = "否",
    Yes = "是",
    language = "语言",
    develop = "开发模式",
    English = "英语",
    Chinese = "中文",
    wormwood = "沃姆伍德开花皮肤",
    ["Traditional Chinese"] = "繁体",
    Default = "默认",
    ["Accord to the game"] = "跟随游戏设置",
    fx = "开启特效",
    ["Don't Reskin"] = "显示原皮",
    ["Keep Invisible"] = "保持透明",
    ["Use Bugged Anim"] = "使用错误的动画",
    ["Fix Invisible Tools"] = "修复透明物品"
  }
}, {
  matchLanguage = function(lang) return lang == "en" end,
  dict = {
    name = name,
    description = description,
    version = "Version: Scrappy Scavenger"
  },
  translateFunction = function(key) return translation[2].dict[key] or key end
} }
local function makeConfigurations(conf, translate, baseTranslate, language)
  local index = 0
  local config = {}
  local function trans(str) return translate(str) or baseTranslate(str) end

  local string = ""
  for i = 1, #conf do
    local v = conf[i]
    if not v.disabled then
      index = index + 1
      config[index] = {
        name = v.name or "",
        label = v.name ~= "" and translate(v.name) or (v.label and trans(v.label)) or baseTranslate(v.name) or nil,
        hover = v.name ~= "" and (v.hover and trans(v.hover)) or nil,
        default = v.default,
        options = v.name ~= "" and { {
          description = "",
          data = ""
        } } or nil,
        client = v.client
      }
      if v.unusable then config[index].label = config[index].label .. "[" .. trans("unusable") .. "]" end
      if v.options then
        for j = 1, #v.options do
          local opt = v.options[j]
          config[index].options[j] = {
            description = opt.description and trans(opt.description) or "",
            hover = opt.hover and trans(opt.hover) or "",
            data = opt.data
          }
        end
      end
    end
  end
  configuration_options = config
end

local function makeInfo(translation)
  local localName = translation("name")
  local localDescription = translation("description")
  local localVersionInfo = translation("version") or ""
  if localVersionInfo ~= "" then
    if not localDescription then localDescription = "" end
    localDescription = localVersionInfo .. "\n" .. localDescription
  end
  if localName then name = localName end
  if localDescription then description = localDescription end
end

local function getLang()
  local lang = locale or "en"
  return lang
end

local function generate()
  local lang = getLang()
  local localTranslation = translation[#translation].translateFunction
  local baseTranslation = translation[#translation].translateFunction
  for i = 1, #translation - 1 do
    local v = translation[i]
    if v.matchLanguage(lang) then
      localTranslation = v.translateFunction
      break
    end
  end
  makeInfo(localTranslation)
  makeConfigurations(configuration, localTranslation, baseTranslation, lang)
end
generate()
