# Introduction

Port DST Skins. You can't use skins unless you own them. The ownership is directly ported from Don't Starve Together save data together with your Klei ID. You should be aware that this mod comes out just because Klei has not and may not pay attention to Don't Starve to support skins.

Do not redistribute skin data. I allow you to use the DST library and skin system, but you should import skin data elsewhere, or use modded skins only.

# Ownership Transfering

copy inventory_cache_prod to the mod directory and to the save directory (In case the file fails to read, put them both places are better).
the file is typically in
`C:\Users\{Your Windows User Name}\Documents\Klei\DoNotStarveTogether\{Your ID}\client_save\`
the save directory is typically in

- Steam Cloud Save (Default):

  `C:\Steam\userdata\{Your Steam ID}\219740\remote\`

- Local Save:

  `C:\Users\{Your Windows User Name}\Documents\Klei\DoNotStarve\save\`

- the mod directory is typically in

  `C:\Steam\steamapps\common\dont_starve\mods\workshop-2883799470\`

# How to Use

- (Deprecated) Console Command: Open console, type:`SetPlayerSkin('skin name here')`
- (WIP) Wardrobe: Just like DST, use it to reskin head base, do not click anything else.
- Clean Sweeper: Just like DST, craft a sweeper and cast magic on anything reskinnable.
- Crafting Menu: Choose skin when you craft, you can mouse wheel through skins. 

# What these mods include and exclude

Most official item skins.

All clothes (with bugs that I'm not planning to fix).

Some FX.

No sound FX.

No special effect. However there are indeed few effects with skins.

Free DLC character. You are allowed to use DST DLC characters' base skin.

All DS shared character head bases.

Some DST exclusive character head bases.

No beard skins.

No beefalo skins.

Walter's hat skins are assigned to winter hat, Wigfrid's spear skins to spear, replica relic chair's skin to relic chair.

# Known Issues

1. Will trigger crash when closing game. This can only be resolved by enabling LuaJIT.
1. Will crash with error "out of memory" when loading save. This can be resolved by setting Dynamic Asset Loading to "All", and/or enabling LuaJIT.
1. DST icons will override those of SW.
2. No water animation, and this cannot be solved.
3. swap_face and other layers are missing.
4. some skins look different with fx.

# Dependency

1. **DST Library**

   Required for its DST library. Size:500KB

2. Skin System

   Required for its skin system. Size:40MB

# Dataset

1. [DST]Character Skin 1

   Contains 130 character skins. Size:63.5MB

2. [DST]Character Skin 2

   Contains 80 character skins. Size:33.2MB

3. [DST]Character Skin 3

   Contains 100 character skins+Wormwood Flower Extender skins. Size:67.8MB

4. [DST]Skin System Data

   If you enable FX, this is required for some zip files within it. Contains 443 item skins and fx. Size:80.1MB

5. [DST]Clothing

   Contains 852 clothes. Size:60.2MB

# Others

1. LuaJIT

   Recommended, Not required. Lua Just-In-Time dll patch mod. Increases the stability and efficiency of lua engine. It is recommended if you run into Out Of Memory crash.

# Troubleshoot

1. Is DST Library enabled?
2. Is any dataset mod enabled?
3. Is inventory_cache_prod there?
4. open console, `print(TheInventory:CheckOwnership('wilson'))`should print true, `print(TheInventory:CheckOwnership('wilson_magma'))`should print whether you own Magma Wilson
5. enter game, open console, `ThePlayer.AnimState:SetBuild("wilson_magma")` should reskin you to Magma Wilson(if you own it, you can change it into another skin you own). If the console says "Animation Missing", you may forget to load relevant dataset.

# Full Item List

```
{Hats}
{Armors}
{Amulets}
{Staffs}
Abigail(Reworked)
Abigail's Flower(Reworked)
(Gloden/) Axe
Backpack
Battle Spear
Bee Box
Bee Mine
Birdcage
Boomerang
Cane
Chest
Chester
Eye Bone
Clean Sweeper
Crock Pot
Dark Sword
Drying Rack
Endothermic Fire Pit
Fire Pit
Ham Bat
Headstone
Ice Box
Ice Flingomatic
Krampus Sack
Lightning Rod
Mini Sign
Opulent Pickaxe
Pan Flute
Pick/Axe
(Gloden/) Pickaxe
Pretty Parasol
Rabbit Hutch
Saddle
Scaled Chest
Science Machine
Shadow Manipulator
Shovel(Golden?)
Stone Wall
Summer Frest
Tail o' Three Cats
Telelocator Focus
Telltale Heart
Tent
The End is Nigh!
Thermal Measurer
Thermal Stone
Thulecite Wall
Tooth Trap
Touch Stone
Trap
Umbrella
Wardrobe
Wood Fence
Wood Wall
Worm Hole
Sign
Alchemy Engine(A bit wrong)
Prestihatitator
Pig House
Wood Gate
Lantern
Bundling Wrap
Bundled Supplies
```
Tested not workable/buggy, some of them still can be equipped, but not on ground:
```
Bug Net
Hammer
Lureplant
Piggyback
Razor
Spear
Thulecite Club
Torch
Feather Fan
```

# 介绍

搬运联机皮肤。除非你拥有该皮肤，你不能使用它。皮肤所有权直接来源于联机版的存档数据，同你的Klei ID一起。你应当知情我之所以做这个mod是因为Klei至今没有、可能也不会重视单机版以支持皮肤。
请勿重新发布皮肤数据。我允许你使用DST库和皮肤系统，但你需要从其他地方获取数据，或者仅使用mod自创皮肤。

# 转移账户信息

复制 inventory_cache_prod 到你的存档文件夹与本mod文件夹（之所以要两份是为了避免读取文件失败）。

这个文件位于
`C:\Users\{你的用户名}\Documents\Klei\DoNotStarveTogether\{你的steam id}\client_save\`
存档文件夹位于

- Steam云存档（默认）`C:\Steam\userdata\{你的steam id}\219740\remote\`

- 本地存档`C:\Users\{你的用户名}\Documents\Klei\DoNotStarve\save\`

mod文件夹位于`C:\Steam\steamapps\common\dont_starve\mods\workshop-2883799470\`

# 使用方法

1. 【过时】打开控制台，输入`SetPlayerSkin(‘皮肤名’)`
2. 【未完成】像联机一样制造衣柜，更换头部皮肤。注意不要点击其他按钮。
3. 像联机一样使用扫把。

# 这些模组包括和不包括什么

包括大部分官方物品皮肤。

包括全部衣物（没有修bug的计划）。

一些皮肤带有特效。

不包括音效特效。

没有特殊效果，但是有一些皮肤会带有一些效果。

可以使用DST免费DLC角色的基础皮肤。

包括所有DS共享的角色头部基础模型。

包括一些DST独有的角色头部基础模型。

不包括胡须皮肤。

不包括牛皮肤。

沃尔特的帽子皮肤给了冬帽，女武神长矛皮肤给长矛，仿制远古椅子皮肤给远古椅子。

# 依赖

1. 联机库

  大小500KB。

2. [DST]皮肤系统

  依赖皮肤系统，大小40MB。

# 数据集

1. [DST]人物皮肤1
  包含130个人物皮肤，大小67.8MB。
2. [DST]人物皮肤2
  包含80个人物皮肤，大小33.2MB。
3. [DST]人物皮肤3
  包含100个人物皮肤+沃姆伍德开花皮肤，大小67.8MB。
4. [DST]皮肤数据
  开启特效则需要其中的几个zip文件。包含443个物品皮肤、特效，大小80.1MB。
5. [DST]衣物皮肤
  包含852个衣物，大小60.2MB。
# 其他

1. LuaJIT
  推荐，非必需。Lua即时加载补丁，能够增强lua的稳定性与速度，建议在发生Out Of Memory崩溃时安装。

# 已知问题

- 联机图标会覆盖海难的。
- 单机动画缺少swap_face等图层。
- 没有水面动画，这没法解决。
- 有些物品的特效看起来很奇怪。

# 物品列表
测试成功：
```
{所有帽子}
{所有甲}
{所有项链}
{所有法杖}
木牌
手杖
三尾猫鞭
传送焦点
兔屋
冰箱
吸热火坑
告密的心
回旋镖
坎普斯背包
墓碑
多用斧镐
小木牌
帐篷
战斗长矛
排箫
(金/)斧头
晾肉架
暖石
暗夜剑
暗影操控器
木墙
木栅栏
末日将至！
清凉夏装
清洁扫把
温度测量仪
火坑
火腿棒
烹饪锅
犬牙陷阱
石墙
科学机器
箱子
背包
花伞
虫洞
蜂箱
蜜蜂地雷
衣柜
试金石
避雷针
铥矿墙
铲子（金？）
阿比盖尔（重做后）
阿比盖尔之花（重做后）
陷阱
雨伞
雪球发射器
鞍具
鸟笼
(金/)鹤嘴锄
龙鳞宝箱
切斯特
眼骨
灵子分解器
炼金引擎
猪房
熊皮大衣
捆绑包装
捆绑物资
提灯
```
测试失败，部分物品在装备时仍然可用，但不会在地面上显示皮肤：

```
锤子
剃刀
捕虫网
铥矿棒
长矛
食人花
小猪包
火把
扇子
```