local ItemSkinner = Class(function(self, inst) self.inst = inst end)
function ItemSkinner:HasSkin() return self.skin_name and self.skin_name ~= "" end
function ItemSkinner:SetSkin(name)
  -- print("ItemSkinner:SetSkin", self.inst, name)
  local pb = self.inst.prefab
  local buildname = GetBuildForItem(name)
  if not name or name == "" then
    if self:HasSkin() then
      self.skin_name = nil
      self.inst.skinname = nil
      self.inst.skin_build_name = nil
      if SKINFNS[pb .. "_clear_fn"] then
        SKINFNS[pb .. "_clear_fn"](self.inst, self.basic_build)
      else
        SKINFNS["basic_clear_fn"](self.inst, self.basic_build)
      end
      if SKINFXFNS[pb .. "_init_fn"] then
        if SKINFXFNS[pb .. "_clear_fn"] then
          SKINFXFNS[pb .. "_clear_fn"](self.inst, buildname)
        else
          SKINFXFNS["basic_clear_fn"](self.inst, buildname)
        end
      end
    end
  else
    if not self:HasSkin() then
      self.basic_build = self.inst.AnimState:GetBuild()
    end
    self.skin_name = name
    self.inst.skinname = name
    self.inst.skin_build_name = nil
    self.inst.skin_id = tostring(math.random(1000000))
    if TheInventory:IsSkinAnimationMissing(name) then
      if ThePlayer.components and ThePlayer.components.talker then
        ThePlayer.components.talker:Say(string.format(STRINGS.MISSINGANIMATION,
                                                      GetSkinName(name), name))
      end
      self.missing_animation = true
      return
    else
      self.missing_animation = false
      if SKINFNS[pb .. "_init_fn"] then
        SKINFNS[pb .. "_init_fn"](self.inst, buildname)
      else
        SKINFNS["basic_init_fn"](self.inst, buildname)
      end
      if SKINFXFNS[pb .. "_init_fn"] then
        SKINFXFNS["basic_init_fn"](self.inst, buildname)
        SKINFXFNS[pb .. "_init_fn"](self.inst, buildname)
      end
    end
  end
  self:RedirectBuild()
end
function ItemSkinner:RedirectBuild()
  if self.inst.components.buildredirector then
    self.inst.components.buildredirector:RedirectBuild(self.inst.prefab,
                                                       self.inst.skin_name)
  end
end
function ItemSkinner:OnSave()
  local ret = {skin_name = self.skin_name}
  if next(ret) then return ret end
  return nil
end

function ItemSkinner:OnLoad(data)
  if data and data.skin_name ~= self.skin_name then
    self:SetSkin(data.skin_name)
  end
end

return ItemSkinner
