--Modded Skins are supported!
local skins = {
    abigail_eyeplant = {
        item = "abigail",
        type = "item",
        rarity = "Reward",
        init_fn = function(inst) abigail_init_fn(inst, "abigail_eyeplant") end,
        tags = {"ABIGAIL", "REWARD", "COSTUME"},
        release_group = 92,
        granted_items = {"abigail_flower_eyeplant"}
    },
    abigail_flower_eyeplant = {
        item = "abigail_flower",
        type = "item",
        rarity = "Reward",
        build = "abigail_eyeplant",
        init_fn = function(inst) abigail_flower_init_fn(inst, "abigail_eyeplant") end,
        invimage = {"abigail_flower_eyeplant", "abigail_flower_eyeplant_level0", "abigail_flower_eyeplant_level2",
                    "abigail_flower_eyeplant_level3"},
        release_group = 92,
        hidden = true
    },
    abigail_flake = {
        item = "abigail",
        type = "item",
        rarity = "Reward",
        init_fn = function(inst) abigail_init_fn(inst, "abigail_flake") end,
        tags = {"ABIGAIL", "REWARD", "ICE"},
        release_group = 36,
        granted_items = {"abigail_flower_flake"}
    },
    abigail_flower_flake = {
        item = "abigail_flower",
        type = "item",
        rarity = "Reward",
        build = "abigail_flake",
        init_fn = function(inst) abigail_flower_init_fn(inst, "abigail_flake") end,
        invimage = {"abigail_flower_flake", "abigail_flower_flake_level0", "abigail_flower_flake_level2",
                    "abigail_flower_flake_level3"},
        release_group = 36,
        hidden = true
    },
    -- both for gladiator and later magma. both belongs to lava.
    abigail_flame = {
        item = "abigail",
        type = "item",
        rarity = "Reward",
        init_fn = function(inst) abigail_init_fn(inst, "abigail_flame") end,
        tags = {"ABIGAIL", "REWARD", "LAVA"},
        release_group = 51,
        granted_items = {"abigail_flower_flame"}
    },
    abigail_flower_flame = {
        item = "abigail_flower",
        type = "item",
        rarity = "Reward",
        build = "abigail_flame",
        init_fn = function(inst)
            abigail_flower_init_fn(inst, "abigail_flame")
            if inst.flame then return end
            local skin_fx = "abigail_flame_fx"
            local fx = SpawnPrefab(skin_fx)
            fx.SetProxy(inst)
            inst.flame = fx
        end,
        invimage = {"abigail_flower_flame", "abigail_flower_flame_level0", "abigail_flower_flame_level2",
                    "abigail_flower_flame_level3"},
        release_group = 51,
        hidden = true
    } -- ,saltlick_wolfgang={item="saltlick",type="item",build="wolfgang_saltlick"},saltlick_wogfrod={item="saltlick",type="item",build="wogfrod_saltlick"},saltlick_edgy={item="saltlick",type="item",build="edgy_saltlick"},cookpot_archivefake={item="cookpot",type="item",build="fake_cookpot_archive"},beebox_hermitfake={item="beebox",type="item",build="fake_beebox_hermit"}
}
for k, v in pairs(skins) do
    v.base_prefab = v.item
    v.build_name_override = v.build
    v.skin_tags = v.tags
    v.fx_prefab = v.fx
    v.marketable = false
    CreatePrefabSkin(k, v)
end
