return function(Builder)
    local old = Builder.DoBuild
    local e = getfenv(old)
    local self = Builder
    local function SpawnPrefabWithSkin(name)
        local ent = SpawnPrefab(name)
        if ent and self.inst.__validateskin then
            -- print("SpawnPrefabWithSkin", name, self.inst.__validateskin)
            if not ent.components.itemskinner then ent:AddComponent("itemskinner") end
            if TheInventory:CheckOwnership(self.inst.__validateskin) then
                local data = GetSkinData(self.inst.__validateskin)
                if data and data.base_prefab == ent.prefab or data.alternate_prefab == ent.prefab then
                    ent.components.itemskinner:SetSkin(self.inst.__validateskin)
                end
            end
            self.inst.__validateskin = nil
        end
        return ent
    end
    -- #TODO:investigate change the env permanently so as to reduce the cost
    local newenv = {
        SpawnPrefab = SpawnPrefabWithSkin -- insert our skinned version of SpawnPrefab
    }
    setmetatable(newenv, {__index = e})
    function Builder:DoBuild(recname, pt, ...)
        setfenv(old, newenv)
        local ret = old(self, recname, pt, ...)
        setfenv(old, e)
        return ret
    end
end
