local EQUIPLAYERS = {
  HEAD = "swap_hat",
  BODY = "swap_body",
  BACK = "swap_body",
  NECK = "swap_body",
  HANDS = "swap_object",
  BEDROLL = "swap_bedroll",
  BERNIE = "swap_object_bernie",
  PICKAXEAXE = "swap_multitool_axe_pickaxe",
  LANTERN = "swap_lantern",
  PACK = "swap_body",
  FAN = "fan01",
  PANFLUTE = "pan_flute01"
}
local function DelayedSet(owner, ...)
  if owner.components.inventory and owner.components.inventory.hascache then
    owner.AnimState:OverrideItemSkinSymbol(...)
  else
    local param = {...}
    owner:DoTaskInTime(FRAMES, function()
      owner.AnimState:OverrideItemSkinSymbol(unpack(param))
    end)
  end
end

local specials = _G.SPECIALSKINFNS or {
  lantern = {
    function(inst, owner)
      DelayedSet(owner, "swap_object", inst:GetSkinBuild(), EQUIPLAYERS.LANTERN)
    end,
    function(inst, owner) owner.AnimState:ClearOverrideSymbol("swap_object") end
  },
  multitool_axe_pickaxe = {
    function(inst, owner)
      DelayedSet(owner, "swap_object", inst:GetSkinBuild(),
                 EQUIPLAYERS.PICKAXEAXE)
    end,
    function(inst, owner) owner.AnimState:ClearOverrideSymbol("swap_object") end
  },
  -- elsewhere, in SG
  panflute = {
    function(inst, owner)
      DelayedSet(owner, EQUIPLAYERS.PANFLUTE, inst:GetSkinBuild(),
                 EQUIPLAYERS.PANFLUTE)
    end, function(inst, owner)
      owner.AnimState:ClearOverrideSymbol(EQUIPLAYERS.PANFLUTE)
    end
  }
}
rawset(_G, "SPECIALSKINFNS", specials)
local STAFFCOLOUR = {
  icestaff = "blue",
  firestaff = "red",
  telestaff = "purple",
  orangestaff = "orange",
  greenstaff = "green",
  yellowstaff = "yellow",
  opalstaff = "opal"
}
return function(Equippable)
  local oldEquip = Equippable.Equip
  function Equippable:Equip(owner, slot, ...)
    local oldbuild, oldsymbol = nil, nil
    --[[
    if owner and owner.components.buildredirector then
      -- switch to the buildredirector to skip rebuild AnimState
      owner.components.buildredirector:Block("OverrideSymbol", function(_, sym, build, overridesym)
        print("got override", sym, build, overridesym)
        oldbuild, oldsymbol = build, overridesym
      end)
    end]]
    oldEquip(self, owner, slot, ...)
    slot = slot or self.equipslot
    if slot and self.inst.components.itemskinner and
      self.inst.components.itemskinner:HasSkin() then
      local prefab = self.inst.prefab
      local uslot = string.upper(slot)
      local layer = EQUIPLAYERS[uslot]
      local skin_build = self.inst:GetSkinBuild()
      local cache = owner.components.inventory and
                      owner.components.inventory.hascache or oldbuild
      -- print("Equipped", self.inst, slot, skin_build)
      if specials[prefab] then
        specials[prefab][1](self.inst, owner)
      elseif STAFFCOLOUR[prefab] then
        DelayedSet(owner, layer, skin_build,
                   "swap_" .. STAFFCOLOUR[prefab] .. "staff", cache)
      elseif slot == EQUIPSLOTS.HANDS then
        if not cache then
          local function set() -- what's wrong with you? Can anybody tell me why I have to delay this?
            local build, sym = owner.AnimState:GetOverrideSymbol(
                                 EQUIPLAYERS.HANDS)
            if sym and sym ~= "" then
              owner.AnimState:OverrideItemSkinSymbol(EQUIPLAYERS.HANDS,
                                                     skin_build, sym)
            end
          end
          for i = 1, 2 do owner:DoTaskInTime(FRAMES * i, set) end
        else
          -- ?
        end
      elseif layer then
        owner.AnimState:OverrideItemSkinSymbol(layer, skin_build, layer)
      else
        print("[Equippable skinned item]Unrecognized slot " .. slot)
      end
      -- elsewhere
      if self.inst:HasTag("fan") then
        -- this is a luxury fan
        local build, sym = owner.AnimState:GetOverrideSymbol(EQUIPLAYERS.HANDS)
        owner.AnimState:OverrideItemSkinSymbol(EQUIPLAYERS.FAN, skin_build, sym)
      end
    end
  end
end
