local SkinSelectorUI = require "widgets/dstskinselector"
local bg_nudgehetight_vertical = Vector3(0, 20, 0)
local nudgeheight_vertical = Vector3(0, -90, 0) - bg_nudgehetight_vertical
local padding = 10 -- magic number
local nudgeheight = -110 -- spinnerheight defined
local bg_height = 432
local bg_y_scale = 1.34 -- good number
local contents_y_nudge = (bg_y_scale - 1) * bg_height / 2
return function(self, horizontal)
    if self.spinner_bg then return end
    if not self.contents then return end
    local oldClick = self.button.onclick
    if oldClick then
        self.button:SetOnClick(function(...)
            -- pass the skinname to DoRecipeClick for crafting skinned items
            self.recipe.skin = self.skins_spinner:GetItem()
            if self.recipe.product then
                LinkSkin(self.recipe.product, self.recipe.skin)
            end
            return oldClick(self, ...)
        end)
    end
    local Refresh = self.Refresh
    function self:Refresh()
        Refresh(self)
        local recipe = self.recipe
        local owner = self.owner
        if not owner then return false end
        --[[
        self.bg:SetPosition(240,40,0)背景
        self.contents:SetPosition(-75,0,0)内容
            self.name:SetPosition(320, 142, 0)名字
            self.desc:SetPosition(320, -5, 0)描述
            self.recipecost:SetPosition(420, -115, 0)???不知道是什么
            self.ing(?,80,0)材料
            self.amulet:SetPosition(415, -105, 0)建造护符
            self.teaser:SetPosition(325, -100, 0)科技提示
            self.button:SetPosition(320, -105, 0)scale=0.7按钮.OnClick=DoRecipeClick
        ]]
        -- #TODO:add a manual update function to spinner, so that I don't need to kill&create each time the recipe changes
        -- bugfix: previously I use :RemoveChild, but it did not remove inst, so these widgets accumulate to near 40000 causing markable lag.
        local x, y, z = self.desc:GetPosition():Get()
        if not self.contentsy then
            self.contentsy = self.contents:GetPosition().y
            self.contentsx = self.contents:GetPosition().x
            -- There is a visual defect that the lighter background is painted into the popup panel, making the description a bit higher.
            for k, v in ipairs({"recipecost", "amulet", "teaser"}) do
                if self[v] then self[v]:Nudge(Vector3(0, nudgeheight, 0)) end
            end
            self.bg:SetScale(1, bg_y_scale, 1)
            self.contents:SetPosition(self.contentsx, self.contentsy + contents_y_nudge)
        end
        if self.button.shown then
            -- according to recipepopup.Refresh, the button always setposition, so we always nudge the button
            self.button:Nudge(Vector3(0, nudgeheight, 0))
        else
        end
        if self.skins_spinner then
            if recipe ~= self.skins_spinner.recipe then
                self.skins_spinner:Refresh(recipe)
            else
                -- recipe is the same, no need to refresh
            end
            return
        end
        -- recipe is new, create a new spinner
        self.skins_spinner = self.contents:AddChild(SkinSelectorUI(recipe, self.owner))
        local spinnerheight = self.skins_spinner.spinner.height + padding -- spinnerheight defined
        self.skins_spinner:SetPosition(x, y - spinnerheight)
    end
    if horizontal then
        local old2 = self.SetPosition
        rawset(self, "SetPosition", function(self, ...)
            old2(self, ...)
            local oldp = self:GetPosition()
            old2(self, oldp + nudgeheight_vertical)
        end)
        local old3 = self.MoveTo
        rawset(self, "MoveTo", function(self, v1, v2, ...)
            v2 = v2 + nudgeheight_vertical
            old3(self, v1, v2, ...)
        end)
        if self.bg then self.bg:Nudge(bg_nudgehetight_vertical) end
    end
end
